--------------------------------------------------------------------
-- X-Isle Script File
-- Description: Defines the binoculars
-- Created by Lennert Schneider
--------------------------------------------------------------------
--Robert-33
--This script now defines slow motion.
--
----
--Beta 6+ notes
--The hud blurring effects are a slight graphics overhead.
--They are very nice, though. However, if they cause problems,
--they may have to be dropped....
--ps.
--Many other people have used similar hud blurring scripts;
--they always seem to overdo it, though.
----

Binoculars = {
	IsActive = 0,		-- initially always 0
	}

-------------------------------------------------------
function Binoculars:OnInit()
Binoculars.StaticNoise=Sound:LoadSound("Sounds/heartbeat_loop.wav");
end

-------------------------------------------------------
function Binoculars:OnShutdown()
Binoculars.IsActive=0;
end

----------------------------------
function Binoculars:OnActivate()
fixed_time_step = 0.01; --was 0.008 in beta 5.
--Note - timestep cannot be above 0.01 (e.g 0.02)
--because motion blur won't function.
g_maxfps = 60; --60 is technical ideal, at least for consoles.
s_SFXVolume = 0.4; --was 0.7, but not quiet enough
Binoculars.IsActive=1;
--New beta 6+
p_speed_crouch=2;
p_speed_run=7;
p_speed_walk=4.25;
p_fixed_time_step = 0.01;
Sound:SetSoundLoop(Binoculars.StaticNoise, 1);
Sound:SetSoundVolume(Binoculars.StaticNoise, 255);
Sound:PlaySound(Binoculars.StaticNoise);
--
end

----------------------------------
function Binoculars:OnDeactivate()
--new beta 6+
p_fixed_time_step = 0;
Sound:StopSound(Binoculars.StaticNoise);
---
fixed_time_step = 0;
g_maxfps = 500;
s_SFXVolume = 1;
	System:SetScreenFx("ScreenBlur" , 0);  --removes tone.   
	p_speed_crouch=1.6;
	p_speed_run=5.0;
	p_speed_walk=3.5;              

end
----------------------------------

----------------------------------
function Binoculars:DrawOverlay()
end

function Binoculars:OnUpdate()
	System:SetScreenFx("ScreenBlur", 1); 
  	System:SetScreenFxParamFloat("ScreenBlur", "ScreenBlurAmount", 0.20);
	System:SetScreenFxParamFloat("ScreenBlur", "ScreenBlurColorRed", 0.50);
	System:SetScreenFxParamFloat("ScreenBlur", "ScreenBlurColorBlue", 1);
	System:SetScreenFxParamFloat("ScreenBlur", "ScreenBlurColorGreen", 0.75);
end

-------------------------------------------------------
-- Restore binoculars data
function Binoculars:OnRestore(pRestoreTbl)
end
